export const metricModifiers: Map<number, string> = new Map([
    [1000000000, "G"],
    [1000000, "M"],
    [1000, "k"],
    [1, ""]
]);

const localization = new Map([
    ["space engineers", new Map([
        ["en-GB", "Space Engineers"]
    ])],
    ["calculator", new Map([
        ["en-GB", "Calculator"],
        ["de-DE", "Rechner"]
    ])],
    ["gravity", new Map([
        ["en-GB", "Gravity"],
        ["de-DE", "Schwerkraft"]
    ])],
    ["inventory", new Map([
        ["en-GB", "Inventory"],
        ["de-DE", "Inventar"]
    ])],
    ["grid", new Map([
        ["en-GB", "Grid"],
        ["de-DE", "Konstrukt"]
    ])],
    ["size", new Map([
        ["en-GB", "Size"],
        ["de-DE", "Größe"]
    ])],
    ["small", new Map([
        ["en-GB", "Small"],
        ["de-DE", "Klein"]
    ])],
    ["large", new Map([
        ["en-GB", "Large"],
        ["de-DE", "Groß"]
    ])],
    ["add", new Map([
        ["en-GB", "Add"],
        ["de-DE", "Hinzufügen"]
    ])],
    ["liftableWeight", new Map([
        ["en-GB", "Liftable Weight"],
        ["de-DE", "Liftkapazität"]
    ])],
    ["liftableVehcileWeight", new Map([
        ["en-GB", "Liftable Vehicle Weight"],
        ["de-DE", "Liftbares Fahrzeuggewicht"]
    ])],
    ["thrust", new Map([
        ["en-GB", "Thrust"],
        ["de-DE", "Schub"]
    ])],
    ["smallGrid", new Map<string, string>([
        ["en-GB", "Small"],
        ["de-DE", "Klein"]
    ])],
    ["largeGrid", new Map<string, string>([
        ["en-GB", "Large"],
        ["de-DE", "Groß"]
    ])],
    ["smallThruster", new Map([
        ["en-GB", "Small"],
        ["de-DE", "Kleiner"]
    ])],
    ["largeThruster", new Map([
        ["en-GB", "Large"],
        ["de-DE", "Großer"]
    ])],
    ["hugeThruster", new Map([
        ["en-GB", "Huge"],
        ["de-DE", "Rießiger"]
    ])],
    ["connector", new Map([
        ["en-GB", "Connector"],
        ["de-DE", "Verbinder"]
    ])],
    ["smallCargo", new Map([
        ["en-GB", "Small Cargo Container"],
        ["de-DE", "Kleiner Frachtcontainer"]
    ])],
    ["mediumCargo", new Map([
        ["en-GB", "Medium Cargo Container"],
        ["de-DE", "Mittlerer Frachtcontainer"]
    ])],
    ["largeCargo", new Map([
        ["en-GB", "Large Cargo Container"],
        ["de-DE", "Großer Frachtcontainer"]
    ])],
    ["fusionThruster", new Map([
        ["en-GB", "Fusion Thruster"],
        ["de-DE", "Fusionstriebwerk"]
    ])],
    ["hydrogenThruster", new Map([
        ["en-GB", "Hydrogen Thruster"],
        ["de-DE", "Wasserstofftriebwerk"]
    ])],
    ["ionThruster", new Map([
        ["en-GB", "Ion Thruster"],
        ["de-DE", "Ionentriebwerk"]
    ])],
    ["atmosphericThruster", new Map([
        ["en-GB", "Atmospheric Thruster"],
        ["de-DE", "Atmosphärentriebwerk"]
    ])],
    ["addInventory", new Map([
        ["en-GB", "Add Inventory"],
        ["de-DE", "Inventar hinzufügen"]
    ])],
    ["multiplier", new Map([
        ["en-GB", "multiplicator"],
        ["de-DE", "Multiplikator"]
    ])],
    ["inventories", new Map([
        ["en-GB", "inventories"],
        ["de-DE", "Inventare"]
    ])],
    ["thrusterSettings", new Map([
        ["en-GB", "Thruster Settings"],
        ["de-DE", "Triebwerk Einstellungen"]
    ])],
    ["thrusters", new Map([
        ["en-GB", "Thrusters"],
        ["de-DE", "Triebwerke"]
    ])],
    ["thruster", new Map([
        ["en-GB", "Thruster"],
        ["de-DE", "Triebwerk"]
    ])],
    ["addThruster", new Map([
        ["en-GB", "Add Thruster"],
        ["de-DE", "Triebwerk Hinzufügen"]
    ])],
    ["inventorySettings", new Map([
        ["en-GB", "Inventory Settings"],
        ["de-DE", "Inventar Einstellungen"]
    ])],
    ["volume", new Map([
        ["en-GB", "Volume"],
        ["de-DE", "Volumen"]
    ])],
    ["title", new Map([
        ["en-GB", "Space Engineers Thrust Calculator"],
        ["de.DE", "Space Engineers Schub Rechner"]
    ])],
    ["gridSize", new Map([
        ["en-GB", "Grid Size"],
        ["de-DE", "Block Größe"]
    ])],
    ["separator", new Map([
        ["en-GB", ","],
        ["de-DE", "."]
    ])],
    ["ore", new Map([
        ["en-GB", "Ore"],
        ["de-DE", "Erz"]
    ])],
    ["platinumIngot", new Map([
        ["en-GB", "Platinum Ingot"],
        ["de-DE", "Platinbarren"]
    ])],
    ["density", new Map([
        ["en-GB", "Density"],
        ["de-DE", "Dichte"]
    ])],
    ["atmosDensity", new Map([
        ["en-GB", "Atmospheric Density"],
        ["de-DE", "Atmosphärendichte"]
    ])],
    ["results", new Map([
        ["en-GB", "Results"],
        ["de-DE", "Ergebnisse"],
    ])],
    ["settings", new Map([
        ["en-GB", "Settings"],
        ["de-DE", "Einstellungen"],
    ])],
    ["fuels", new Map([
        ["en-GB", "Fuels"],
        ["de-DE", "Treibstoffe"],
    ])],
    ["fuel", new Map([
        ["en-GB", "Fuel"],
        ["de-DE", "Treibstoff"],
    ])],
    ["electric", new Map([
        ["en-GB", "Electricity"],
        ["de-DE", "Elektrizität"],
    ])],
    ["hydrogen", new Map([
        ["en-GB", "Hydrogen"],
        ["de-DE", "Wasserstoff"],
    ])],
    ["deuterium", new Map([
        ["en-GB", "Deuterium"],
        ["de-DE", "Deuterium"],
    ])],
    ["vehicleWeightInTons", new Map([
        ["en-GB", "Vehicle Weight (in tons)"],
        ["de-DE", "Fahrzeug Gewicht (in Tonnen)"],
    ])],
    ["full", new Map([
        ["en-GB", "full"],
        ["de-DE", "voll"],
    ])],
    ["empty", new Map([
        ["en-GB", "empty"],
        ["de-DE", "leer"],
    ])],
    ["acceleration", new Map([
        ["en-GB", "Acceleration"],
        ["de-DE", "Beschleunigung"],
    ])]
])


export class Localization {
    dictionary: Map<string, Map<string, string>>;
    language: string;

    constructor(language: string) {
        this.language = language;
        this.dictionary = localization;
    };

    localize(key: string): string {
        let localizationObject = this.dictionary.get(key)

        if (typeof localizationObject === "undefined") {
            return `missing text: ${key}`
        }
        else {
            let localizedText = localizationObject.get(this.language)
            if (typeof localizedText === "undefined") {
                return localizationObject.get("en-GB") || `mising text: ${key}`;
            }
            else {
                return localizedText
            }
        }
    }
}

export function getFromLocalStorage(key: string) {
    let val = localStorage.getItem(key);
    if (val !== null && typeof val !== "undefined" && val !== '{}') {
        return { result: true, value: val };
    }
    else {
        return { result: false, value: undefined };
    }
}

export function applyUnits(i18n: Localization, value: number, unit: string): string {
    for (const [power, modifier] of [...metricModifiers.entries()]) {
        if (value > power) {
            if (value / power >= 10000) {
                let base = value / power;
                let rest = base % 1000;
                base = (base - rest) / 1000;
                rest = Math.round((rest + Number.EPSILON) * 100) / 100
                return `${base}${i18n.localize("separator")}${rest}${modifier}${unit}`
            }
            else {
                let rounded = Math.round(((value / power) + Number.EPSILON) * 100) / 100
                return `${rounded}${modifier}${unit}`
            }
        }
    }
    if (value < 0) {
        return `-${applyUnits(i18n,value * -1, unit)}`
    }
    let rounded = Math.round(((value + Number.EPSILON) * 100) / 100)
    return `${rounded}${unit}`
}

export function weightConversion(i18n: Localization, weight: number): string {
    if (weight > 1000 || weight < -1000) {
        return applyUnits(i18n, weight/1000, "t")
    }
    else {
        return `${(weight * 100).toFixed(2) || (weight * 100) / 100}kg`
    }
}