export class CargoMaterial {
    static readonly Ore: CargoMaterial = new CargoMaterial('ore', 1/0.37);
    static readonly PlatinumIngot: CargoMaterial = new CargoMaterial('platinumIngot', 1/0.047);

    readonly density: number;
    readonly name: string;

    private constructor(name: string, density: number) {
        this.name = name;
        this.density = density;
    }
    
    static load(name: string) {
        let ret = CargoMaterial.Ore;
        Object.values(CargoMaterial).forEach((material) => {
            if (material.name === name) {
                ret = material;
            }
        })
        return ret;
    }

    save() {
        return this.name;
    }
}